﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication24
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {            
            // Apply a summary to Band 1 (the child band)
            UltraGridBand childBand = e.Layout.Bands["ChildBand"];
            childBand.Summaries.Add(Infragistics.Win.UltraWinGrid.SummaryType.Sum, childBand.Columns[0]);

            // Add an unbound column to the parent band to hold the child band total. 
            UltraGridBand parentBand = e.Layout.Bands["ParentBand"];
            UltraGridColumn totalColumn = parentBand.Columns.Add("Total");
            totalColumn.DataType = typeof(int);  
          
            // Add a summary to the parent band for a grand total
            parentBand.Summaries.Add(SummaryType.Sum, totalColumn);
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            // If this is a parent band row, get the value from the summary of the child rows
            // and use it to populate the unbound column. 
            if (e.Row.Band.Key == "ParentBand" &&
                e.Row.Cells.Exists("Total"))
            {
                e.Row.Cells["Total"].Value = e.Row.ChildBands["ChildBand"].Rows.SummaryValues[0].Value;
            }                
        }

        private void ultraGrid1_SummaryValueChanged(object sender, SummaryValueChangedEventArgs e)
        {
            // Populate the unbound column in the parent band with the value of the summary in the
            // child band. 
            if (e.SummaryValue.ParentRows.Band.Key == "ChildBand")
                e.SummaryValue.ParentRows.ParentRow.Cells["Total"].Value = e.SummaryValue.Value;
        }
    }
}
